SystemOrganization addCategory: #'Seaside-Benchmark'!

WASession subclass: #WAPredictableSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WAPredictableSession commentStamp: 'pmm 5/22/2011 11:32' prior: 0!
A WAPredictableSession has linearly incremented continuation keys. This is unsafe but helpful for testing and benchmarking because it makes recording and replaying session possible because the URLs are always the same.

The benchmarking tool has to support cookies for the sessions. Make sure the benchmarking tool supports redirects, otherwise you'll have to record the action "pages" as well.!

!WAPredictableSession class methodsFor: 'initialization' stamp: 'pmm 5/22/2011 11:58'!
registerCounter
	"registers a counter at '/counter' that is tweaked for benchmarking"
	^ self registerForBenchmarking: WACounter at: 'counter'! !

!WAPredictableSession class methodsFor: 'initialization' stamp: 'pmm 7/16/2011 14:51'!
registerForBenchmarking: aComponentClass at: aString
	"registers a counter at '/counter' that is tweaked for benchmarking"
	| application |
	application := (WAAdmin register: aComponentClass asApplicationAt: aString)
		preferenceAt: #sessionClass put: WAPredictableSession; " -> always the same continuation keys"
		preferenceAt: #trackingStrategy put: WACookieOnlySessionTrackingStrategy new; "cookies -> no session in URL"
		yourself.
	"remove the development tools"
	application configuration removeParent: WAAdmin applicationDefaults.
	application configuration addParent: (WAAdmin applicationDefaults copy
		removeParent: WADevelopmentConfiguration instance;
		yourself).
	^ application! !

!WAPredictableSession methodsFor: 'initialization' stamp: 'pmm 5/22/2011 11:08'!
createCache
	^ WAPredictableCache new! !

WARequestHandler subclass: #WACounterRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WACounterRenderer commentStamp: 'pmm 5/22/2011 11:37' prior: 0!
I'm a request handler that renders the HTML equivalent of a WACounter.!

!WACounterRenderer class methodsFor: 'class initialization' stamp: 'pmm 5/22/2011 11:35'!
register
	WADispatcher default
		register: self new at: 'fast-counter'! !

!WACounterRenderer methodsFor: 'handling' stamp: 'pmm 5/22/2011 11:35'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			contentType: WAMimeType textHtml;
			nextPutAll: self pageContent ]! !

!WACounterRenderer methodsFor: 'private' stamp: 'pmm 1/22/2012 16:13'!
pageContent
	^ WAHtmlCanvas builder
		fullDocument: true;
		rootBlock: [ :root | root title: 'counter' ];
		render: [ :html |
			html heading: 0.
			html anchor
				with: '++'.
			html space.
			html anchor
				with: '--' ]! !

WARequestHandler subclass: #WADwBenchHandler
	instanceVariableNames: 'pageContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WADwBenchHandler class methodsFor: 'class initialization' stamp: 'pmm 2/25/2012 17:20'!
register
	WADispatcher default
		register: self new at: 'dw-bench' ! !

!WADwBenchHandler methodsFor: 'handling' stamp: 'pmm 2/25/2012 17:19'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			binary;
			contentType: WAMimeType textHtml;
			nextPutAll: self pageContent ]! !

!WADwBenchHandler methodsFor: 'private' stamp: 'pmm 2/25/2012 17:20'!
pageContent
	"taken from seaside.st"
	pageContent isNil ifTrue: [
		pageContent := '<html>
<head>
 <title>DW-Bench Static</title>
</head>
<body>
<h1>DW-Bench Static</h1>
<table border="1">
<tr><td>1</td><td>2</td><td>3</td><td>4</td><td>5</td><td>6</td><td>7</td><td>8</td><td>9</td><td>10</td><td>11</td><td>12</td><td>13</td><td>14</td><td>15</td><td>16</td><td>17</td><td>18</td><td>19</td><td>20</td><td>21</td><td>22</td><td>23</td><td>24</td><td>25</td></tr><tr><td>2</td><td>4</td><td>6</td><td>8</td><td>10</td><td>12</td><td>14</td><td>16</td><td>18</td><td>20</td><td>22</td><td>24</td><td>26</td><td>28</td><td>30</td><td>32</td><td>34</td><td>36</td><td>38</td><td>40</td><td>42</td><td>44</td><td>46</td><td>48</td><td>50</td></tr><tr><td>3</td><td>6</td><td>9</td><td>12</td><td>15</td><td>18</td><td>21</td><td>24</td><td>27</td><td>30</td><td>33</td><td>36</td><td>39</td><td>42</td><td>45</td><td>48</td><td>51</td><td>54</td><td>57</td><td>60</td><td>63</td><td>66</td><td>69</td><td>72</td><td>75</td></tr><tr><td>4</td><td>8</td><td>12</td><td>16</td><td>20</td><td>24</td><td>28</td><td>32</td><td>36</td><td>40</td><td>44</td><td>48</td><td>52</td><td>56</td><td>60</td><td>64</td><td>68</td><td>72</td><td>76</td><td>80</td><td>84</td><td>88</td><td>92</td><td>96</td><td>100</td></tr><tr><td>5</td><td>10</td><td>15</td><td>20</td><td>25</td><td>30</td><td>35</td><td>40</td><td>45</td><td>50</td><td>55</td><td>60</td><td>65</td><td>70</td><td>75</td><td>80</td><td>85</td><td>90</td><td>95</td><td>100</td><td>105</td><td>110</td><td>115</td><td>120</td><td>125</td></tr><tr><td>6</td><td>12</td><td>18</td><td>24</td><td>30</td><td>36</td><td>42</td><td>48</td><td>54</td><td>60</td><td>66</td><td>72</td><td>78</td><td>84</td><td>90</td><td>96</td><td>102</td><td>108</td><td>114</td><td>120</td><td>126</td><td>132</td><td>138</td><td>144</td><td>150</td></tr><tr><td>7</td><td>14</td><td>21</td><td>28</td><td>35</td><td>42</td><td>49</td><td>56</td><td>63</td><td>70</td><td>77</td><td>84</td><td>91</td><td>98</td><td>105</td><td>112</td><td>119</td><td>126</td><td>133</td><td>140</td><td>147</td><td>154</td><td>161</td><td>168</td><td>175</td></tr><tr><td>8</td><td>16</td><td>24</td><td>32</td><td>40</td><td>48</td><td>56</td><td>64</td><td>72</td><td>80</td><td>88</td><td>96</td><td>104</td><td>112</td><td>120</td><td>128</td><td>136</td><td>144</td><td>152</td><td>160</td><td>168</td><td>176</td><td>184</td><td>192</td><td>200</td></tr><tr><td>9</td><td>18</td><td>27</td><td>36</td><td>45</td><td>54</td><td>63</td><td>72</td><td>81</td><td>90</td><td>99</td><td>108</td><td>117</td><td>126</td><td>135</td><td>144</td><td>153</td><td>162</td><td>171</td><td>180</td><td>189</td><td>198</td><td>207</td><td>216</td><td>225</td></tr><tr><td>10</td><td>20</td><td>30</td><td>40</td><td>50</td><td>60</td><td>70</td><td>80</td><td>90</td><td>100</td><td>110</td><td>120</td><td>130</td><td>140</td><td>150</td><td>160</td><td>170</td><td>180</td><td>190</td><td>200</td><td>210</td><td>220</td><td>230</td><td>240</td><td>250</td></tr><tr><td>11</td><td>22</td><td>33</td><td>44</td><td>55</td><td>66</td><td>77</td><td>88</td><td>99</td><td>110</td><td>121</td><td>132</td><td>143</td><td>154</td><td>165</td><td>176</td><td>187</td><td>198</td><td>209</td><td>220</td><td>231</td><td>242</td><td>253</td><td>264</td><td>275</td></tr><tr><td>12</td><td>24</td><td>36</td><td>48</td><td>60</td><td>72</td><td>84</td><td>96</td><td>108</td><td>120</td><td>132</td><td>144</td><td>156</td><td>168</td><td>180</td><td>192</td><td>204</td><td>216</td><td>228</td><td>240</td><td>252</td><td>264</td><td>276</td><td>288</td><td>300</td></tr><tr><td>13</td><td>26</td><td>39</td><td>52</td><td>65</td><td>78</td><td>91</td><td>104</td><td>117</td><td>130</td><td>143</td><td>156</td><td>169</td><td>182</td><td>195</td><td>208</td><td>221</td><td>234</td><td>247</td><td>260</td><td>273</td><td>286</td><td>299</td><td>312</td><td>325</td></tr><tr><td>14</td><td>28</td><td>42</td><td>56</td><td>70</td><td>84</td><td>98</td><td>112</td><td>126</td><td>140</td><td>154</td><td>168</td><td>182</td><td>196</td><td>210</td><td>224</td><td>238</td><td>252</td><td>266</td><td>280</td><td>294</td><td>308</td><td>322</td><td>336</td><td>350</td></tr><tr><td>15</td><td>30</td><td>45</td><td>60</td><td>75</td><td>90</td><td>105</td><td>120</td><td>135</td><td>150</td><td>165</td><td>180</td><td>195</td><td>210</td><td>225</td><td>240</td><td>255</td><td>270</td><td>285</td><td>300</td><td>315</td><td>330</td><td>345</td><td>360</td><td>375</td></tr><tr><td>16</td><td>32</td><td>48</td><td>64</td><td>80</td><td>96</td><td>112</td><td>128</td><td>144</td><td>160</td><td>176</td><td>192</td><td>208</td><td>224</td><td>240</td><td>256</td><td>272</td><td>288</td><td>304</td><td>320</td><td>336</td><td>352</td><td>368</td><td>384</td><td>400</td></tr><tr><td>17</td><td>34</td><td>51</td><td>68</td><td>85</td><td>102</td><td>119</td><td>136</td><td>153</td><td>170</td><td>187</td><td>204</td><td>221</td><td>238</td><td>255</td><td>272</td><td>289</td><td>306</td><td>323</td><td>340</td><td>357</td><td>374</td><td>391</td><td>408</td><td>425</td></tr><tr><td>18</td><td>36</td><td>54</td><td>72</td><td>90</td><td>108</td><td>126</td><td>144</td><td>162</td><td>180</td><td>198</td><td>216</td><td>234</td><td>252</td><td>270</td><td>288</td><td>306</td><td>324</td><td>342</td><td>360</td><td>378</td><td>396</td><td>414</td><td>432</td><td>450</td></tr><tr><td>19</td><td>38</td><td>57</td><td>76</td><td>95</td><td>114</td><td>133</td><td>152</td><td>171</td><td>190</td><td>209</td><td>228</td><td>247</td><td>266</td><td>285</td><td>304</td><td>323</td><td>342</td><td>361</td><td>380</td><td>399</td><td>418</td><td>437</td><td>456</td><td>475</td></tr><tr><td>20</td><td>40</td><td>60</td><td>80</td><td>100</td><td>120</td><td>140</td><td>160</td><td>180</td><td>200</td><td>220</td><td>240</td><td>260</td><td>280</td><td>300</td><td>320</td><td>340</td><td>360</td><td>380</td><td>400</td><td>420</td><td>440</td><td>460</td><td>480</td><td>500</td></tr><tr><td>21</td><td>42</td><td>63</td><td>84</td><td>105</td><td>126</td><td>147</td><td>168</td><td>189</td><td>210</td><td>231</td><td>252</td><td>273</td><td>294</td><td>315</td><td>336</td><td>357</td><td>378</td><td>399</td><td>420</td><td>441</td><td>462</td><td>483</td><td>504</td><td>525</td></tr><tr><td>22</td><td>44</td><td>66</td><td>88</td><td>110</td><td>132</td><td>154</td><td>176</td><td>198</td><td>220</td><td>242</td><td>264</td><td>286</td><td>308</td><td>330</td><td>352</td><td>374</td><td>396</td><td>418</td><td>440</td><td>462</td><td>484</td><td>506</td><td>528</td><td>550</td></tr><tr><td>23</td><td>46</td><td>69</td><td>92</td><td>115</td><td>138</td><td>161</td><td>184</td><td>207</td><td>230</td><td>253</td><td>276</td><td>299</td><td>322</td><td>345</td><td>368</td><td>391</td><td>414</td><td>437</td><td>460</td><td>483</td><td>506</td><td>529</td><td>552</td><td>575</td></tr><tr><td>24</td><td>48</td><td>72</td><td>96</td><td>120</td><td>144</td><td>168</td><td>192</td><td>216</td><td>240</td><td>264</td><td>288</td><td>312</td><td>336</td><td>360</td><td>384</td><td>408</td><td>432</td><td>456</td><td>480</td><td>504</td><td>528</td><td>552</td><td>576</td><td>600</td></tr><tr><td>25</td><td>50</td><td>75</td><td>100</td><td>125</td><td>150</td><td>175</td><td>200</td><td>225</td><td>250</td><td>275</td><td>300</td><td>325</td><td>350</td><td>375</td><td>400</td><td>425</td><td>450</td><td>475</td><td>500</td><td>525</td><td>550</td><td>575</td><td>600</td><td>625</td></tr>

</table>
<p>This is the static DW-Bench page</p>
</body>    
</html>' asByteArray ].
	^ pageContent! !

WARequestHandler subclass: #WAFastRequestHandler
	instanceVariableNames: 'pageContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WAFastRequestHandler commentStamp: 'pmm 2/17/2012 07:16' prior: 0!
I return a static 16k byte array. This number is the number of bytes in the Seaside homepage. I'm useful for benchmarking the HTTP server and server adatper.!

!WAFastRequestHandler class methodsFor: 'class initialization' stamp: 'pmm 5/22/2011 11:33'!
register
	WADispatcher default
		register: self new at: 'fast' ! !

!WAFastRequestHandler methodsFor: 'handling' stamp: 'pmm 5/22/2011 11:33'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			binary;
			contentType: WAMimeType textHtml;
			nextPutAll: self pageContent ]! !

!WAFastRequestHandler methodsFor: 'private' stamp: 'pmm 1/22/2012 16:13'!
pageContent
	"taken from seaside.st"
	pageContent isNil ifTrue: [
		pageContent := '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"><head><title>seaside.st: Home</title><link type="image/x-icon" rel="shortcut icon" href="/favicon.ico"/><link type="image/png" rel="icon" href="/favicon.png"/><link rel="stylesheet" type="text/css" media="all" href="/styles/main.css"/><link rel="stylesheet" type="text/css" media="all" href="/styles/shout.css"/><link rel="stylesheet" type="text/css" media="all" href="/styles/seaside.css"/><link rel="stylesheet" type="text/css" media="print" href="/styles/print.css"/><script type="text/javascript" src="/scripts/prototype.js"></script><script type="text/javascript" src="/scripts/effects.js"></script><script type="text/javascript" src="/scripts/controls.js"></script><script type="text/javascript" src="http://www.google-analytics.com/urchin.js"></script><script type="text/javascript">_uacct=''UA-2075184-3'';urchinTracker();</script><meta name="verify-v1" content="fZCcMGYJZDwS/679EfUS+VeqtrMDrxUQ1f6n3H0nXkE="/><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/><meta http-equiv="Content-Script-Type" content="text/javascript"/><meta name="generator" content="Pier - Magritte - Seaside"/><link rel="canonical" href="http://www.seaside.st/"/><meta name="robots" content="index,follow"/><meta name="keywords" content="seaside.st Home"/></head><body onload="onLoad()" class="page viewcommand defaultview"><div id="head"> <div class="columns">       <div class="search"><input id="id1" onfocus="if(value==''Search the Seaside''){value='''';style.color=null}" style="color: #aaa" value="Search the Seaside" onkeypress="if((window.event ? window.event.keyCode : event.which) == 13){id3.activate(); return false}; return true" name="4" type="text" class="text"/><div id="id8"></div></div>     <div class="clear"></div>   </div></div> <div id="desk" class="root">   <div class="columns">   <div id="home" class="quadruple"><img src="/styles/logo-plain.png" alt="Seaside - The framework for developing sophisticated web applications in Smalltalk" width="265" height="142" style="vertical-align: top; margin-right: -53px" /><img src="/styles/slogan.09.png" alt="" width="613" height="180"/></div>    <div class="clear"></div> </div>   <div id="entry" class="columns">     <div class="quadruple"><h1 class="heading">Home</h1></div>     <div class="clear"></div>   </div>   <div id="body" class="columns">     <div class="single"><h1><a name="164699393"></a><a title="About" class="internal page" href="http://www.seaside.st/about?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;9">About</a></h1><ul><li> <a title="Screenshots" class="internal page" href="http://www.seaside.st/about/screenshots?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;10">Screenshots</a></li><li> <a title="Examples" class="internal page" href="http://www.seaside.st/about/examples?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;11">Examples</a></li><li> <a title="Hosting" class="internal page" href="http://www.seaside.st/about/hosting?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;12">Hosting</a></li><li> <a title="Support" class="internal page" href="http://www.seaside.st/about/support?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;13">Support</a></li><li> <a title="Success Stories" class="internal page" href="http://www.seaside.st/about/users?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;14">Success Stories</a></li></ul><div class="more"><a title="About" class="internal page" href="http://www.seaside.st/about?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;15">more</a></div><h1><a name="199529418"></a><a title="Documentation" class="internal page" href="http://www.seaside.st/documentation?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;16">Documentation</a></h1><a style="margin-right:0.5em;float:left;" title="http://book.seaside.st/book" class="external" href="http://book.seaside.st/book"><img alt="Cover.png" src="/files/3b/lbfipy0c0wupv716l87fdya0uhq9q8/cover.png"/></a> The open book <a title="http://book.seaside.st/book" class="external" href="http://book.seaside.st/book">Dynamic Web Development with Seaside</a> is available online. <a title="http://book.seaside.st/book/introduction/pdf-book/" class="external" href="http://book.seaside.st/book/introduction/pdf-book/">Pdf</a> and <a title="http://book.seaside.st/book/introduction/print-book/" class="external" href="http://book.seaside.st/book/introduction/print-book/">paper</a> versions are available too.<div class="clear"><br/></div>Also see: <a title="Frequently Asked Questions" class="internal page" href="http://www.seaside.st/documentation/faq?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;17">FAQ</a>, <a title="Tutorials" class="internal page" href="http://www.seaside.st/documentation/tutorials?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;18">Tutorials</a>, <a title="Migration" class="internal page" href="http://www.seaside.st/documentation/migration?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;19">Migration</a>, <a title="Videos" class="internal page" href="http://www.seaside.st/documentation/videos?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;20">Videos</a>, and <a title="Documentation" class="internal page" href="http://www.seaside.st/documentation?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;21">more</a>.</div>     <div class="single"><h1><a name="85066451"></a><a title="Community" class="internal page" href="http://www.seaside.st/community?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;22">Community</a></h1><ul><li> <a title="Weblogs" class="internal page" href="http://www.seaside.st/community/weblogs?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;23">Weblogs</a></li><li> <a title="Mailing Lists" class="internal page" href="http://www.seaside.st/community/mailinglist?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;24">Mailing Lists</a></li><li> <a title="Development" class="internal page" href="http://www.seaside.st/community/development?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;25">Development</a></li><li> <a title="Contribute" class="internal page" href="http://www.seaside.st/community/contribute?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;26">Contribute</a></li><li> <a title="Merchandise" class="internal page" href="http://www.seaside.st/about/merchandise?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;27">Merchandise</a></li><li> <a title="Extensions" class="internal page" href="http://www.seaside.st/community/extensions?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;28">Extensions</a></li><li> <a title="Projects" class="internal page" href="http://www.seaside.st/community/projects?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;29">Projects</a></li></ul><div class="more"><a title="Community" class="internal page" href="http://www.seaside.st/community?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;30">more</a></div> <br/><h1><a name="77063584"></a><a title="New in Seaside 3.0" class="internal page" href="http://www.seaside.st/community/development/seaside30?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;31">Seaside 3.0</a></h1> <a class="internal" title="Rendering Speed" href="http://www.seaside.st/?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;32"><img alt="Rendering Speed" src="/files/36/4azto1togfy64byx0dzr5hut1tkfgx/002.gif"/></a></div>     <div class="single"><h1><a name="182558962"></a><a title="Weblogs" class="internal page" href="http://www.seaside.st/community/weblogs?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;33">News</a></h1><ul class="hfeed"><li><a class="entry-title" href="http://newringo.blogspot.com/2010/10/smalltalk.html">: Smalltalk</a>&nbsp;<abbr class="published" title="2010-10-31T13:40:00+00:00">2010-10-31T13:40:00+00:00</abbr><div class="entry-summary">Smalltalk.  http://docs.google.com/viewer?a=v&pid=sites&srcid= ... (9) Unix (9) iPad (9) App (8) Com...</div></li><li><a class="entry-title" href="http://www.jarober.com/blog/blogView?showComments=true&amp;printTitle=SeaBreeze_Progress&amp;entry=3465698764">SeaBreeze Progress</a>&nbsp;<abbr class="published" title="2010-10-28T06:06:04+00:00">2010-10-28T06:06:04+00:00</abbr><div class="entry-summary">Georg Heeg announced an update to SeaBreeze, their GUI builder front end to Seaside: Currently we ar...</div></li><li><a class="entry-title" href="http://sickfirst.info/2010/10/25/diamond-series-disk-blades-tillage/">diamond series disk blades tillage</a>&nbsp;<abbr class="published" title="2010-10-25T09:26:28+00:00">2010-10-25T09:26:28+00:00</abbr><div class="entry-summary">... an aluminium of rough process since at due others it mirrors to smalltalk. During the color, imr...</div></li><li><a class="entry-title" href="http://maxiarticles.com/typical-areas-of-web-development.html">Typical Areas of Web Development - The World Articles Guide Online ...</a>&nbsp;<abbr class="published" title="2010-10-24T14:40:44+00:00">2010-10-24T14:40:44+00:00</abbr><div class="entry-summary">Lotus Domino PHP Python, e.g. Django (web framework) (open source) Ruby, e.g. Ruby on Rails (open so...</div></li><li><a class="entry-title" href="http://www.partyperfectrentals.com/wordpress/?p=1036">ESUG 2010 Next Generation Event Planning System with Seaside  part 1</a>&nbsp;<abbr class="published" title="2010-10-22T19:31:17+00:00">2010-10-22T19:31:17+00:00</abbr><div class="entry-summary">In this talk, we will demonstrate the application and focus on how Seaside and Smalltalk are ideal t...</div></li></ul> <div class="more"><a title="Weblogs" class="internal page" href="http://www.seaside.st/community/weblogs?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;34">more</a></div></div>     <div id="download" class="single"><h1><a name="192286684"></a><a title="Download" class="internal page" href="http://www.seaside.st/download?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;35">Download</a></h1><p><a href="http://www.opensource.org/licenses/mit-license.php" class="opensource">www.opensource.org</a>Seaside is a free and <a title="http://www.opensource.org/licenses/mit-license.php" class="external" href="http://www.opensource.org/licenses/mit-license.php">Open Source</a> web application framework distributed under the <a title="MIT License" class="internal page" href="http://www.seaside.st/about/license?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;36">MIT License</a>.</p><p>Seaside is available on the following Smalltalk platforms:</p><ul><li> <a title="Pharo Smalltalk" class="internal page" href="http://www.seaside.st/download/pharo?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;37">Pharo Smalltalk</a> (<a title="http://www.seaside.st/distributions/Seaside-3.0-final.app.zip" class="external" href="http://www.seaside.st/distributions/Seaside-3.0-final.app.zip">download</a>)</li><li> <a title="Cincom Smalltalk" class="internal page" href="http://www.seaside.st/download/vw?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;38">Cincom Smalltalk</a></li><li> <a title="Dolphin Smalltalk" class="internal page" href="http://www.seaside.st/download/dolphin?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;39">Dolphin Smalltalk</a></li><li> <a title="GemStone Smalltalk" class="internal page" href="http://www.seaside.st/download/gemstone?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;40">GemStone Smalltalk</a></li><li> <a title="GNU Smalltalk" class="internal page" href="http://www.seaside.st/download/gst?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;41">GNU Smalltalk</a></li><li> <a title="Squeak Smalltalk" class="internal page" href="http://www.seaside.st/download/squeak?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;42">Squeak Smalltalk</a></li><li> <a title="VA Smalltalk" class="internal page" href="http://www.seaside.st/download/vast?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;43">VA Smalltalk</a></li></ul><div class="more"><a title="Download" class="internal page" href="http://www.seaside.st/download?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;44">more</a></div> <br/><p><a href="http://www.esug.org"><img src="http://www.seaside.st/styles/esug.gif" alt="Approved by ESUG" width="160" height="66" /></a></p></div>     <div class="clear"></div>   </div> </div> <div id="foot">   <div class="columns">       <div id="navigation" class="single"><h1><a name="111710222"></a>Navigation</h1><ul><li><a title="About" class="page" href="http://www.seaside.st/about?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;45">About</a></li><li><a title="Download" class="page" href="http://www.seaside.st/download?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;46">Download</a></li><li><a title="Community" class="page" href="http://www.seaside.st/community?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;47">Community</a></li><li><a title="Documentation" class="page" href="http://www.seaside.st/documentation?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;48">Documentation</a></li><li><a title="Seaside 3.0 Release Announcement" class="page" href="http://www.seaside.st/seaside30?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;49">Seaside 3.0 Release Announcement</a></li></ul></div>      <div id="participate" class="single"><h1><a name="10281304"></a>Participate</h1><ul><li> <a title="Mailing Lists" class="internal page" href="http://www.seaside.st/community/mailinglist?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;50">Mailing Lists</a>: Ask questions and talk with Seaside experts.</li><li> <a title="Weblogs" class="internal page" href="http://www.seaside.st/community/weblogs?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;51">Weblogs</a>: Read the latest news about the Seaside community.</li><li> <a title="Contribute" class="internal page" href="http://www.seaside.st/community/contribute?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;52">Contribute</a>: Help to improve code and documentation of Seaside.</li></ul></div>      <div id="activity" class="single"> <h1><a name="102496547"></a>Activity</h1><ul class="hfeed"><li><a class="entry-title" href="http://code.google.com/p/seaside/issues/detail?id=606#c2">Update 2 to issue 606 ("WAKomEncoded fails serving CSS files from WAExternalFileLibrary")</a>&nbsp;<abbr class="published" title="2010-10-28T16:14:49+00:00">2010-10-28T16:14:49+00:00</abbr><div class="entry-summary">Name: Seaside-FileSystem-pmm.24
Author: pmm
Time: 28 October 2010, 6:14:01 pm
UUID: eef2a50b-2b13-4f8e-a3af-3d008e6fcd9d
Ancestors: Seaside-FileSystem-lr.23

- Issue 606:    WAKomEncoded fails serv...</div></li><li><a class="entry-title" href="http://code.google.com/p/seaside/issues/detail?id=606#c1">Update 1 to issue 606 ("WAKomEncoded fails serving CSS files from WAExternalFileLibrary")</a>&nbsp;<abbr class="published" title="2010-10-28T05:03:00+00:00">2010-10-28T05:03:00+00:00</abbr><div class="entry-summary">Should happen with pretty much every adapter since the content is bytes but the content type is character based.
 
 Status: AcceptedLabels: Version-Seaside3.0 Kom Swazoo Encoding 
 </div></li></ul></div>         <div id="powered" class="single">This website is run on <a title="http://www.squeak.org" class="external" href="http://www.squeak.org">Squeak</a>, <a title="Home" class="internal page" href="http://www.seaside.st/?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;_n&amp;53">Seaside</a> and is powered by the <a title="http://www.lukas-renggli.ch/smalltalk/pier" class="external" href="http://www.lukas-renggli.ch/smalltalk/pier">Pier</a> CMS. The design was kindly provided by Samuel Morello. The site is hosted on a server of <a title="http://www.netstyle.ch" class="external" href="http://www.netstyle.ch">netstyle.ch</a>.</div>       <div class="clear"></div>   </div> </div>  <div id="login"><ul><li><a accesskey="l" title="Login (l)" class="page" href="http://www.seaside.st/?_s=yXH_sTmmADG3DLbl&amp;_k=udgqUBC3&amp;command=PULogin&amp;_n&amp;54">Login</a></li></ul></div><script type="text/javascript">/*<!![CDATA[*/function onLoad(){id3=new Ajax.Autocompleter(''id1'',''id8'',''http://www.seaside.st/'',{''evalScripts'':true,''parameters'':[''_s=yXH_sTmmADG3DLbl'',''_k=udgqUBC3'',''5''].join(''&''),''afterUpdateElement'':function(){new Ajax.Request(''http://www.seaside.st/'',{''parameters'':[''_s=yXH_sTmmADG3DLbl'',''_k=udgqUBC3'',''6'',''7=''+arguments[1].id.match(/^_p([0-9]+)$/)[1]].join(''&'')})}})}/*]]>*/</script></body></html>' asByteArray ].
	^ pageContent! !

WARequestHandler subclass: #WASmallRequestHandler
	instanceVariableNames: 'pageContent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WASmallRequestHandler commentStamp: 'pmm 2/17/2012 07:14' prior: 0!
I return a static 2 byte array. I'm useful for benchmarking the HTTP server and server adatper for req/s.!

!WASmallRequestHandler class methodsFor: 'class initialization' stamp: 'pmm 2/17/2012 07:12'!
register
	WADispatcher default
		register: self new at: 'small' ! !

!WASmallRequestHandler methodsFor: 'handling' stamp: 'pmm 2/17/2012 07:12'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			binary;
			contentType: WAMimeType textHtml;
			nextPutAll: self pageContent ]! !

!WASmallRequestHandler methodsFor: 'private' stamp: 'pmm 2/17/2012 07:12'!
pageContent
	"taken from seaside.st"
	pageContent isNil ifTrue: [
		pageContent := 'OK' asByteArray ].
	^ pageContent! !

WARequestHandler subclass: #WAWebPageRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Benchmark'!

!WAWebPageRenderer commentStamp: 'pmm 5/22/2011 11:36' prior: 0!
I render the HTML of the www.seaside.st home page. I'm useful for benchmarking the Seaside rendering code.!

!WAWebPageRenderer class methodsFor: 'class initialization' stamp: 'pmm 5/22/2011 11:36'!
register
	WADispatcher default
		register: self new at: 'fast-page'! !

!WAWebPageRenderer methodsFor: 'handling' stamp: 'pmm 5/22/2011 11:36'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			contentType: WAMimeType textHtml;
			nextPutAll: self pageContent ]! !

!WAWebPageRenderer methodsFor: 'private' stamp: 'pmm 1/22/2012 16:14'!
pageContent
	^ WAHtmlCanvas builder
		fullDocument: true;
		rootBlock: [ :root | self updateRoot: root ];
		render: [ :html |
			self renderContentOn: html ]! !

!WAWebPageRenderer methodsFor: 'rendering' stamp: 'pmm 9/2/2012 11:12'!
renderContentOn: html
    html div id: 'head'; with: [
        html div class: 'columns'; with: [
            html div class: 'search'; with: [
                html numberInput type: 'text'; class: 'text'; name: 4; onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){id3.activate(); return false}; return true'; text: 'Search the Seaside'; style: 'color: #aaa'; onFocus: 'if(value==''Search the Seaside''){value='''';style.color=null}'; id: 'id1'; "unmapped attribute->" attributeAt: 'autocomplete' put: 'off'.
                html div id: 'id8'; style: 'display: none;' ].
            html div class: 'clear' ] ].
    html div class: 'root'; id: 'desk'; with: [
        html div class: 'columns'; with: [
            html div class: 'quadruple'; id: 'home'; with: [
                html image width: 265; height: 142; style: 'vertical-align: top; margin-right: -53px'; altText: 'Seaside - The framework for developing sophisticated web applications in Smalltalk'; resourceUrl: '/styles/logo-plain.png'.
                html image width: 613; height: 180; altText: ''; resourceUrl: '/styles/slogan.07.png' ].
            html div class: 'clear' ].
        html div class: 'columns'; id: 'entry'; with: [
            html div class: 'quadruple'; with: [
                html heading class: 'heading'; level: 1; with: 'Home' ].
            html div class: 'clear' ].
        html div class: 'columns'; id: 'body'; with: [
            html div class: 'single'; with: [
                html heading level: 1; with: [
                    html anchor name: 164699393.
                    html anchor url: 'http://www.seaside.st/about?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&9'; class: 'internal page'; title: 'About'; with: 'About' ].
                html unorderedList:[
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/screenshots?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&10'; class: 'internal page'; title: 'Screenshots'; with: 'Screenshots' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/examples?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&11'; class: 'internal page'; title: 'Examples'; with: 'Examples' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/hosting?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&12'; class: 'internal page'; title: 'Hosting'; with: 'Hosting' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/support?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&13'; class: 'internal page'; title: 'Support'; with: 'Support' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/users?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&14'; class: 'internal page'; title: 'Success Stories'; with: 'Success Stories' ] ].
                html div class: 'more'; with: [
                    html anchor url: 'http://www.seaside.st/about?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&15'; class: 'internal page'; title: 'About'; with: 'more' ].
                html heading level: 1; with: [
                    html anchor name: 199529418.
                    html anchor url: 'http://www.seaside.st/documentation?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&16'; class: 'internal page'; title: 'Documentation'; with: 'Documentation' ].
                html anchor url: 'http://book.seaside.st/book'; class: 'external'; title: 'http://book.seaside.st/book'; style: 'margin-right:0.5em;float:left;'; with: [
                    html image resourceUrl: '/files/3b/lbfipy0c0wupv716l87fdya0uhq9q8/cover.png'; altText: 'Cover.png' ].
                html text:' The open book '.
                html anchor url: 'http://book.seaside.st/book'; class: 'external'; title: 'http://book.seaside.st/book'; with: 'Dynamic Web Development with Seaside'.
                html text:' is available online. '.
                html anchor url: 'http://book.seaside.st/book/introduction/pdf-book/'; class: 'external'; title: 'http://book.seaside.st/book/introduction/pdf-book/'; with: 'Pdf'.
                html text:' and '.
                html anchor url: 'http://book.seaside.st/book/introduction/print-book/'; class: 'external'; title: 'http://book.seaside.st/book/introduction/print-book/'; with: 'paper'.
                html text:' versions are available too.'.
                html div class: 'clear'; with: [
                    html break ].
                html text:'Also see: '.
                html anchor url: 'http://www.seaside.st/documentation/faq?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&17'; class: 'internal page'; title: 'Frequently Asked Questions'; with: 'FAQ'.
                html text:', '.
                html anchor url: 'http://www.seaside.st/documentation/tutorials?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&18'; class: 'internal page'; title: 'Tutorials'; with: 'Tutorials'.
                html text:', '.
                html anchor url: 'http://www.seaside.st/documentation/migration?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&19'; class: 'internal page'; title: 'Migration'; with: 'Migration'.
                html text:', '.
                html anchor url: 'http://www.seaside.st/documentation/videos?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&20'; class: 'internal page'; title: 'Videos'; with: 'Videos'.
                html text:', and '.
                html anchor url: 'http://www.seaside.st/documentation?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&21'; class: 'internal page'; title: 'Documentation'; with: 'more'.
                html text:'.' ].
            html div class: 'single'; with: [
                html heading level: 1; with: [
                    html anchor name: 85066451.
                    html anchor url: 'http://www.seaside.st/community?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&22'; class: 'internal page'; title: 'Community'; with: 'Community' ].
                html unorderedList:[
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/weblogs?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&23'; class: 'internal page'; title: 'Weblogs'; with: 'Weblogs' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/mailinglist?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&24'; class: 'internal page'; title: 'Mailing Lists'; with: 'Mailing Lists' ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/development?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&25'; class: 'internal page'; title: 'Development'; with: 'Development'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/contribute?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&26'; class: 'internal page'; title: 'Contribute'; with: 'Contribute'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about/merchandise?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&27'; class: 'internal page'; title: 'Merchandise'; with: 'Merchandise'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/extensions?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&28'; class: 'internal page'; title: 'Extensions'; with: 'Extensions'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/projects?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&29'; class: 'internal page'; title: 'Projects'; with: 'Projects'
                    ]
                ].
                html div class: 'more'; with: [
                    html anchor url: 'http://www.seaside.st/community?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&30'; class: 'internal page'; title: 'Community'; with: 'more'
                ].
                html break.
                html heading level: 1; with: [
                    html anchor name: 77063584.
                    html anchor url: 'http://www.seaside.st/community/development/seaside30?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&31'; class: 'internal page'; title: 'New in Seaside 3.0'; with: 'Seaside 3.0'
                ].
                html anchor url: 'http://www.seaside.st/?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&32'; title: 'Unit Tests'; class: 'internal'; with: [
                    html image resourceUrl: '/files/5f/3fi9bi61xf9rz941ogtl1vxfoosr6i/000.gif'; altText: 'Unit Tests'
                ]
            ].
            html div class: 'single'; with: [
                html heading level: 1; with: [
                    html anchor name: 182558962.
                    html anchor url: 'http://www.seaside.st/community/weblogs?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&33'; class: 'internal page'; title: 'Weblogs'; with: 'News'
                ].
                html unorderedList class: 'hfeed'; with: [
                    html listItem:[
                        html anchor url: 'http://schrievkrom.wordpress.com/2010/11/02/vasmalltalk-smalltalk-experience/'; class: 'entry-title'; with: 'VASmalltalk  Smalltalk Experience | Schrievkrom'.
                        html abbreviated title: '2010-11-02T20:36:27+00:00'; class: 'published'; with: '2010-11-02T20:36:27+00:00'.
                        html div class: 'entry-summary'; with: 'While in the stage of producing these reduced images I recognized, that there is no real good docume...'
                    ].
                    html listItem:[
                        html anchor url: 'http://astares.blogspot.com/2010/11/ob-web-javascriptajaxsmalltalk-server.html'; class: 'entry-title'; with: 'The Hitchhiker''s Guide to ...: OB-Web - JavaScript/AJAX/Smalltalk ...'.
                        html abbreviated title: '2010-11-02T18:04:00+00:00'; class: 'published'; with: '2010-11-02T18:04:00+00:00'.
                        html div class: 'entry-summary'; with: 'Compared to the standard web based browser tool that comes with the Seaside web framework the one fr...'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.fastcashdesign.com/2010/11/seaside-tutorial-part-1/'; class: 'entry-title'; with: 'Seaside Tutorial Part 1  Web Development Videos  Videos  Fast ...'.
                        html abbreviated title: '2010-11-02T00:11:50+00:00'; class: 'published'; with: '2010-11-02T00:11:50+00:00'.
                        html div class: 'entry-summary'; with: 'Part 1 of the Cincom Smalltalk Seaside Tutorial Rating: 0 | Views: 1373. Share/Save. Sorry, the comm...'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.jarober.com/blog/blogView?showComments=true&printTitle=Seaside_in_Toronto&entry=3466098392'; class: 'entry-title'; with: 'Seaside in Toronto'.
                        html abbreviated title: '2010-11-01T21:06:32+00:00'; class: 'published'; with: '2010-11-01T21:06:32+00:00'.
                        html div class: 'entry-summary'; with: 'The Toronto Smalltalkers are having a Seaside evening: The next meeting of the Toronto Smalltalk Use...'
                    ].
                    html listItem:[
                        html anchor url: 'http://wdtoolkit.com/2010/11/01/why-i-have-migrated-from-ruby-on-rails-to-seaside-2/'; class: 'entry-title'; with: 'Why I have migrated from Ruby on Rails to Seaside'.
                        html abbreviated title: '2010-11-01T15:42:24+00:00'; class: 'published'; with: '2010-11-01T15:42:24+00:00'.
                        html div class: 'entry-summary'; with: 'Ruby on Rails user tells why he switched to Smalltalk & Seaside. Read the full article at the source...'
                    ]
                ].
                html div class: 'more'; with: [
                    html anchor url: 'http://www.seaside.st/community/weblogs?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&34'; class: 'internal page'; title: 'Weblogs'; with: 'more'
                ]
            ].
            html div class: 'single'; id: 'download'; with: [
                html heading level: 1; with: [
                    html anchor name: 192286684.
                    html anchor url: 'http://www.seaside.st/download?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&35'; class: 'internal page'; title: 'Download'; with: 'Download'
                ].
                html paragraph:[
                    html anchor class: 'opensource'; url: 'http://www.opensource.org/licenses/mit-license.php'; with: 'www.opensource.org'.
                    html text:'Seaside is a free and '.
                    html anchor url: 'http://www.opensource.org/licenses/mit-license.php'; class: 'external'; title: 'http://www.opensource.org/licenses/mit-license.php'; with: 'Open Source'.
                    html text:' web application framework distributed under the '.
                    html anchor url: 'http://www.seaside.st/about/license?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&36'; class: 'internal page'; title: 'MIT License'; with: 'MIT License'.
                    html text:'.'
                ].
                html paragraph:'Seaside is available on the following Smalltalk platforms:'.
                html unorderedList:[
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/pharo?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&37'; class: 'internal page'; title: 'Pharo Smalltalk'; with: 'Pharo Smalltalk'.
                        html text:' ('.
                        html anchor url: 'http://www.seaside.st/distributions/Seaside-3.0-final.app.zip'; class: 'external'; title: 'http://www.seaside.st/distributions/Seaside-3.0-final.app.zip'; with: 'download'.
                        html text:')'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/vw?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&38'; class: 'internal page'; title: 'Cincom Smalltalk'; with: 'Cincom Smalltalk'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/dolphin?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&39'; class: 'internal page'; title: 'Dolphin Smalltalk'; with: 'Dolphin Smalltalk'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/gemstone?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&40'; class: 'internal page'; title: 'GemStone Smalltalk'; with: 'GemStone Smalltalk'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/gst?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&41'; class: 'internal page'; title: 'GNU Smalltalk'; with: 'GNU Smalltalk'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/squeak?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&42'; class: 'internal page'; title: 'Squeak Smalltalk'; with: 'Squeak Smalltalk'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download/vast?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&43'; class: 'internal page'; title: 'VA Smalltalk'; with: 'VA Smalltalk'
                    ]
                ].
                html div class: 'more'; with: [
                    html anchor url: 'http://www.seaside.st/download?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&44'; class: 'internal page'; title: 'Download'; with: 'more'
                ].
                html break.
                html paragraph:[
                    html anchor url: 'http://www.esug.org'; with: [
                        html image width: 160; height: 66; altText: 'Approved by ESUG'; resourceUrl: 'http://www.seaside.st/styles/esug.gif'
                    ]
                ]
            ].
            html div class: 'clear'.
        ].
    ].
    html div id: 'foot'; with: [
        html div class: 'columns'; with: [
            html div class: 'single'; id: 'navigation'; with: [
                html heading level: 1; with: [
                    html anchor name: 111710222.
                    html text:'Navigation'
                ].
                html unorderedList:[
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/about?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&45'; class: 'page'; title: 'About'; with: 'About'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/download?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&46'; class: 'page'; title: 'Download'; with: 'Download'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&47'; class: 'page'; title: 'Community'; with: 'Community'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/documentation?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&48'; class: 'page'; title: 'Documentation'; with: 'Documentation'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/seaside30?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&49'; class: 'page'; title: 'Seaside 3.0 Release Announcement'; with: 'Seaside 3.0 Release Announcement'
                    ]
                ]
            ].
            html div class: 'single'; id: 'participate'; with: [
                html heading level: 1; with: [
                    html anchor name: 10281304.
                    html text:'Participate'
                ].
                html unorderedList:[
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/mailinglist?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&50'; class: 'internal page'; title: 'Mailing Lists'; with: 'Mailing Lists'.
                        html text:': Ask questions and talk with Seaside experts.'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/weblogs?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&51'; class: 'internal page'; title: 'Weblogs'; with: 'Weblogs'.
                        html text:': Read the latest news about the Seaside community.'
                    ].
                    html listItem:[
                        html anchor url: 'http://www.seaside.st/community/contribute?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&52'; class: 'internal page'; title: 'Contribute'; with: 'Contribute'.
                        html text:': Help to improve code and documentation of Seaside.'
                    ]
                ]
            ].
            html div class: 'single'; id: 'activity'; with: [
                html heading level: 1; with: [
                    html anchor name: 102496547.
                    html text:'Activity'
                ].
                html unorderedList class: 'hfeed'; with: [
                    html listItem:[
                        html anchor url: 'http://code.google.com/p/seaside/issues/detail?id=607#c1'; class: 'entry-title'; with: 'Update 1 to issue 607 ("No adapter can be stared if two stopped adapters are on the same port")'.
                        html abbreviated title: '2010-11-01T08:43:11+00:00'; class: 'published'; with: '2010-11-01T08:43:11+00:00'.
                        html div class: 'entry-summary'; with: 'This must be a regression... I certainly tested that behaviour when I wrote it.
 
 '
                    ].
                    html listItem:[
                        html anchor url: 'http://code.google.com/p/seaside/issues/detail?id=607'; class: 'entry-title'; with: 'Issue 607 created: "No adapter can be stared if two stopped adapters are on the same port"'.
                        html abbreviated title: '2010-11-01T07:58:35+00:00'; class: 'published'; with: '2010-11-01T07:58:35+00:00'.
                        html div class: 'entry-summary'; with: 'What steps will reproduce the problem?
1. Create an adapter on port 8080
2. Create a second adapter on port 8080
3. Start the first adatper

What is the expected output?
The first adapter can be ...'
                    ]
                ]
            ].
            html div class: 'single'; id: 'powered'; with: [
                html text:'This website is run on '.
                html anchor url: 'http://www.squeak.org'; class: 'external'; title: 'http://www.squeak.org'; with: 'Squeak'.
                html text:', '.
                html anchor url: 'http://www.seaside.st/?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&_n&53'; class: 'internal page'; title: 'Home'; with: 'Seaside'.
                html text:' and is powered by the '.
                html anchor url: 'http://www.lukas-renggli.ch/smalltalk/pier'; class: 'external'; title: 'http://www.lukas-renggli.ch/smalltalk/pier'; with: 'Pier'.
                html text:' CMS. The design was kindly provided by Samuel Morello. The site is hosted on a server of '.
                html anchor url: 'http://www.netstyle.ch'; class: 'external'; title: 'http://www.netstyle.ch'; with: 'netstyle.ch'.
                html text:'.'
            ].
            html div class: 'clear'.
        ].
    ].
    html div id: 'login'; with: [
        html unorderedList:[
            html listItem:[
                html anchor url: 'http://www.seaside.st/?_s=NLql1IePoRspC9yy&_k=ApjT6OTa&command=PULogin&_n&54'; class: 'page'; title: 'Login (l)'; accessKey: 'l'; with: 'Login'
            ]
        ]
    ].
    html script "unmapped attribute->" attributeAt: 'type' put: 'text/javascript'; with: 'function onLoad(){id3=new Ajax.Autocompleter(''id1'',''id8'',''http://www.seaside.st/'',{''evalScripts'':true,''parameters'':[''_s=NLql1IePoRspC9yy'',''_k=ApjT6OTa'',''5''].join(''&''),''afterUpdateElement'':function(){new Ajax.Request(''http://www.seaside.st/'',{''parameters'':[''_s=NLql1IePoRspC9yy'',''_k=ApjT6OTa'',''6'',''7=''+arguments[1].id.match(/^_p([0-9]+)$/)[1]].join(''&'')})}})}'
! !

!WAWebPageRenderer methodsFor: 'rendering' stamp: 'pmm 5/22/2011 11:36'!
updateRoot: anHTMLRoot
    anHTMLRoot title:'seaside.st: Home'.
    anHTMLRoot link beShortcutIcon; url: '/favicon.ico'.
    
    anHTMLRoot stylesheet url: '/styles/main.css'.
    anHTMLRoot stylesheet url: '/styles/shout.css'.
    anHTMLRoot stylesheet url: '/styles/seaside.css'.
    anHTMLRoot stylesheet url: '/styles/print.css'.
    anHTMLRoot script url: '/scripts/prototype.js'; beJavascript.
    anHTMLRoot script url: '/scripts/effects.js'; beJavascript.
    anHTMLRoot script url: '/scripts/controls.js'; beJavascript.
    anHTMLRoot script url: 'http://www.google-analytics.com/urchin.js'; beJavascript.
    anHTMLRoot script beJavascript; with: '_uacct=''UA-2075184-3'';urchinTracker();'.
    anHTMLRoot meta contentScriptType: 'fZCcMGYJZDwS/679EfUS+VeqtrMDrxUQ1f6n3H0nXkE='; name: 'verify-v1'.
    anHTMLRoot meta contentScriptType: 'Pier - Magritte - Seaside'; name: 'generator'.
    anHTMLRoot meta contentScriptType: 'index,follow'; name: 'robots'.
    anHTMLRoot meta contentScriptType: 'seaside.st Home'; name: 'keywords'
! !
